//------------------------------------
// "oculi in purpura"
// 512 bytes intro
// by wacek/arise
//------------------------------------

.var counter = $a0

			* = $2000
			
			.import binary "assets\corrected_06 - Chars.bin"
			
start:		sei
			ldx #$0e
			stx $d023

			stx $d418
			
			lda #$3a
			sta $d406
			sta $d406 + 7
			sta $d406 + 14
	
			lda tempo: #$28	
			sta $d018
	
			ldx #$03
			stx $d021
			inx
			stx $d022
			stx $d020
			
gfx_depack_loop:	
			ldx here1: #0
			lda gfx_data,x
			beq pre_play
			tax
			
			lsr
			lsr
			lsr
			clc
			tay
			sta here3
			txa
			and #%00000111

!loop:		sta here2: $07ff,y
			dey
			bne !loop-
			
			lda here2
			adc here3: #0
			sta here2
			bcc !skip+
			
			inc here2 + 1
		
!skip:		inc here1			
			
			bne gfx_depack_loop

pre_play:	sta $3fff
			sta counter

play:		lda $d012

			and #$07
			ora #$10
			tax
			
			lda $d012

!loop:		cmp $d012
			beq !loop-
			
			stx $d016
			
			cmp #$f9
			bne play

			// open border
			
			lda #%00010011
			sta $d011

msx_play:	dec tempo
			bne do_border
			
!skip:		lda #$18	
			sta tempo	
				
			ldx counter	
			ldy #0
			lda track1,x	
			beq !release+	
				
			// play channel 1	
				
!skip:		jsr play_note	
			bne !skip+

!release:	jsr do_release
				
!skip:		ldx counter	
			ldy #7
			lda track2,x	
			beq !release+	

			// play channel 2

			jsr play_note	
			bne !skip+

!release:	jsr do_release
				
!skip:		ldx counter				
			ldy #14
			lda track3,x				
			beq !release+				

			// play channel 3

			jsr play_note	
			bne !skip+

!release:	jsr do_release
				
!skip:		inc counter	
			lda counter	
			cmp #$0c	
			bne !skip+	
				
			lda #0	
			sta counter	
				
!skip:		
do_border:	lda #$fd
!loop:		cmp $d012
			bne !loop-
			
			lda #%00011011
			sta $d011

			bne play

do_release:
			lda #$10
			bne !skip+
play_note:							
			tax	
			lda note_lo,x	
			sta $d400,y	
			lda note_hi,x	
			sta $d401,y	
			lda #$11	
!skip:
			sta $d404,y	
note_lo:	rts	

			.byte $23,$70,$e0,$c0,$80
note_hi:	.byte $a9
			.byte $1d,$03,$06,$0d,$1b,$08

track1:		.byte 2,0,0,5,0,0,2,0,0,1,0		
track2:		.byte 0,3,0,0,3,0,0,3,0,0,6		
track3:		.byte 0,0,4,0,0,4,0,0,4,0,0,3

gfx_data:	.import binary "assets\packed.corrected_10 - Map (8bpc, 40x25).bin",0,173		
			.byte 8 * 31
			.byte 8 * 31
			.byte 8 * 31
			.byte 0

//------------------------------------
// all ends here.
//------------------------------------